// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: circuitsegmentservicemodule/circuitsegmentservicemodule.proto

package openfmb.circuitsegmentservicemodule;

/**
 * <pre>
 * OpenFMB specialization for circuit segment service control, DCSC (Distributed Coordination
 * Service Control), following 61850 naming convention.
 * </pre>
 *
 * Protobuf type {@code circuitsegmentservicemodule.CircuitSegmentEventDCSC}
 */
public final class CircuitSegmentEventDCSC extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:circuitsegmentservicemodule.CircuitSegmentEventDCSC)
    CircuitSegmentEventDCSCOrBuilder {
private static final long serialVersionUID = 0L;
  // Use CircuitSegmentEventDCSC.newBuilder() to construct.
  private CircuitSegmentEventDCSC(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private CircuitSegmentEventDCSC() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new CircuitSegmentEventDCSC();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.circuitsegmentservicemodule.Circuitsegmentservicemodule.internal_static_circuitsegmentservicemodule_CircuitSegmentEventDCSC_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.circuitsegmentservicemodule.Circuitsegmentservicemodule.internal_static_circuitsegmentservicemodule_CircuitSegmentEventDCSC_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC.class, openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC.Builder.class);
  }

  public static final int LOGICALNODE_FIELD_NUMBER = 1;
  private openfmb.commonmodule.LogicalNode logicalNode_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the logicalNode field is set.
   */
  @java.lang.Override
  public boolean hasLogicalNode() {
    return logicalNode_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
   * @return The logicalNode.
   */
  @java.lang.Override
  public openfmb.commonmodule.LogicalNode getLogicalNode() {
    return logicalNode_ == null ? openfmb.commonmodule.LogicalNode.getDefaultInstance() : logicalNode_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.LogicalNodeOrBuilder getLogicalNodeOrBuilder() {
    return logicalNode_ == null ? openfmb.commonmodule.LogicalNode.getDefaultInstance() : logicalNode_;
  }

  public static final int CIRCUITSEGMENTSERVICEMODE_FIELD_NUMBER = 2;
  private openfmb.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind circuitSegmentServiceMode_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind CircuitSegmentServiceMode = 2;</code>
   * @return Whether the circuitSegmentServiceMode field is set.
   */
  @java.lang.Override
  public boolean hasCircuitSegmentServiceMode() {
    return circuitSegmentServiceMode_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind CircuitSegmentServiceMode = 2;</code>
   * @return The circuitSegmentServiceMode.
   */
  @java.lang.Override
  public openfmb.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind getCircuitSegmentServiceMode() {
    return circuitSegmentServiceMode_ == null ? openfmb.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind.getDefaultInstance() : circuitSegmentServiceMode_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind CircuitSegmentServiceMode = 2;</code>
   */
  @java.lang.Override
  public openfmb.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKindOrBuilder getCircuitSegmentServiceModeOrBuilder() {
    return circuitSegmentServiceMode_ == null ? openfmb.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind.getDefaultInstance() : circuitSegmentServiceMode_;
  }

  public static final int ISLAND_FIELD_NUMBER = 3;
  private openfmb.commonmodule.StatusSPS island_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.StatusSPS Island = 3;</code>
   * @return Whether the island field is set.
   */
  @java.lang.Override
  public boolean hasIsland() {
    return island_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.StatusSPS Island = 3;</code>
   * @return The island.
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPS getIsland() {
    return island_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : island_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.StatusSPS Island = 3;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPSOrBuilder getIslandOrBuilder() {
    return island_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : island_;
  }

  public static final int PERMISSIBLEAUTO_FIELD_NUMBER = 4;
  private openfmb.commonmodule.StatusSPS permissibleAuto_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.StatusSPS PermissibleAuto = 4;</code>
   * @return Whether the permissibleAuto field is set.
   */
  @java.lang.Override
  public boolean hasPermissibleAuto() {
    return permissibleAuto_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.StatusSPS PermissibleAuto = 4;</code>
   * @return The permissibleAuto.
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPS getPermissibleAuto() {
    return permissibleAuto_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : permissibleAuto_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.StatusSPS PermissibleAuto = 4;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPSOrBuilder getPermissibleAutoOrBuilder() {
    return permissibleAuto_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : permissibleAuto_;
  }

  public static final int PERMISSIBLEMANUAL_FIELD_NUMBER = 5;
  private openfmb.commonmodule.StatusSPS permissibleManual_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.StatusSPS PermissibleManual = 5;</code>
   * @return Whether the permissibleManual field is set.
   */
  @java.lang.Override
  public boolean hasPermissibleManual() {
    return permissibleManual_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.StatusSPS PermissibleManual = 5;</code>
   * @return The permissibleManual.
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPS getPermissibleManual() {
    return permissibleManual_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : permissibleManual_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.StatusSPS PermissibleManual = 5;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPSOrBuilder getPermissibleManualOrBuilder() {
    return permissibleManual_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : permissibleManual_;
  }

  public static final int PERMISSIBLENETZERO_FIELD_NUMBER = 6;
  private openfmb.commonmodule.StatusSPS permissibleNetzero_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.StatusSPS PermissibleNetzero = 6;</code>
   * @return Whether the permissibleNetzero field is set.
   */
  @java.lang.Override
  public boolean hasPermissibleNetzero() {
    return permissibleNetzero_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.StatusSPS PermissibleNetzero = 6;</code>
   * @return The permissibleNetzero.
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPS getPermissibleNetzero() {
    return permissibleNetzero_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : permissibleNetzero_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.StatusSPS PermissibleNetzero = 6;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPSOrBuilder getPermissibleNetzeroOrBuilder() {
    return permissibleNetzero_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : permissibleNetzero_;
  }

  public static final int PERMISSIBLESTART_FIELD_NUMBER = 7;
  private openfmb.commonmodule.StatusSPS permissibleStart_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.StatusSPS PermissibleStart = 7;</code>
   * @return Whether the permissibleStart field is set.
   */
  @java.lang.Override
  public boolean hasPermissibleStart() {
    return permissibleStart_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.StatusSPS PermissibleStart = 7;</code>
   * @return The permissibleStart.
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPS getPermissibleStart() {
    return permissibleStart_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : permissibleStart_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.StatusSPS PermissibleStart = 7;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPSOrBuilder getPermissibleStartOrBuilder() {
    return permissibleStart_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : permissibleStart_;
  }

  public static final int PERMISSIBLESTOP_FIELD_NUMBER = 8;
  private openfmb.commonmodule.StatusSPS permissibleStop_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.StatusSPS PermissibleStop = 8;</code>
   * @return Whether the permissibleStop field is set.
   */
  @java.lang.Override
  public boolean hasPermissibleStop() {
    return permissibleStop_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.StatusSPS PermissibleStop = 8;</code>
   * @return The permissibleStop.
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPS getPermissibleStop() {
    return permissibleStop_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : permissibleStop_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.StatusSPS PermissibleStop = 8;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPSOrBuilder getPermissibleStopOrBuilder() {
    return permissibleStop_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : permissibleStop_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (logicalNode_ != null) {
      output.writeMessage(1, getLogicalNode());
    }
    if (circuitSegmentServiceMode_ != null) {
      output.writeMessage(2, getCircuitSegmentServiceMode());
    }
    if (island_ != null) {
      output.writeMessage(3, getIsland());
    }
    if (permissibleAuto_ != null) {
      output.writeMessage(4, getPermissibleAuto());
    }
    if (permissibleManual_ != null) {
      output.writeMessage(5, getPermissibleManual());
    }
    if (permissibleNetzero_ != null) {
      output.writeMessage(6, getPermissibleNetzero());
    }
    if (permissibleStart_ != null) {
      output.writeMessage(7, getPermissibleStart());
    }
    if (permissibleStop_ != null) {
      output.writeMessage(8, getPermissibleStop());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (logicalNode_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getLogicalNode());
    }
    if (circuitSegmentServiceMode_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getCircuitSegmentServiceMode());
    }
    if (island_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getIsland());
    }
    if (permissibleAuto_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(4, getPermissibleAuto());
    }
    if (permissibleManual_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(5, getPermissibleManual());
    }
    if (permissibleNetzero_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(6, getPermissibleNetzero());
    }
    if (permissibleStart_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(7, getPermissibleStart());
    }
    if (permissibleStop_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(8, getPermissibleStop());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC)) {
      return super.equals(obj);
    }
    openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC other = (openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC) obj;

    if (hasLogicalNode() != other.hasLogicalNode()) return false;
    if (hasLogicalNode()) {
      if (!getLogicalNode()
          .equals(other.getLogicalNode())) return false;
    }
    if (hasCircuitSegmentServiceMode() != other.hasCircuitSegmentServiceMode()) return false;
    if (hasCircuitSegmentServiceMode()) {
      if (!getCircuitSegmentServiceMode()
          .equals(other.getCircuitSegmentServiceMode())) return false;
    }
    if (hasIsland() != other.hasIsland()) return false;
    if (hasIsland()) {
      if (!getIsland()
          .equals(other.getIsland())) return false;
    }
    if (hasPermissibleAuto() != other.hasPermissibleAuto()) return false;
    if (hasPermissibleAuto()) {
      if (!getPermissibleAuto()
          .equals(other.getPermissibleAuto())) return false;
    }
    if (hasPermissibleManual() != other.hasPermissibleManual()) return false;
    if (hasPermissibleManual()) {
      if (!getPermissibleManual()
          .equals(other.getPermissibleManual())) return false;
    }
    if (hasPermissibleNetzero() != other.hasPermissibleNetzero()) return false;
    if (hasPermissibleNetzero()) {
      if (!getPermissibleNetzero()
          .equals(other.getPermissibleNetzero())) return false;
    }
    if (hasPermissibleStart() != other.hasPermissibleStart()) return false;
    if (hasPermissibleStart()) {
      if (!getPermissibleStart()
          .equals(other.getPermissibleStart())) return false;
    }
    if (hasPermissibleStop() != other.hasPermissibleStop()) return false;
    if (hasPermissibleStop()) {
      if (!getPermissibleStop()
          .equals(other.getPermissibleStop())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasLogicalNode()) {
      hash = (37 * hash) + LOGICALNODE_FIELD_NUMBER;
      hash = (53 * hash) + getLogicalNode().hashCode();
    }
    if (hasCircuitSegmentServiceMode()) {
      hash = (37 * hash) + CIRCUITSEGMENTSERVICEMODE_FIELD_NUMBER;
      hash = (53 * hash) + getCircuitSegmentServiceMode().hashCode();
    }
    if (hasIsland()) {
      hash = (37 * hash) + ISLAND_FIELD_NUMBER;
      hash = (53 * hash) + getIsland().hashCode();
    }
    if (hasPermissibleAuto()) {
      hash = (37 * hash) + PERMISSIBLEAUTO_FIELD_NUMBER;
      hash = (53 * hash) + getPermissibleAuto().hashCode();
    }
    if (hasPermissibleManual()) {
      hash = (37 * hash) + PERMISSIBLEMANUAL_FIELD_NUMBER;
      hash = (53 * hash) + getPermissibleManual().hashCode();
    }
    if (hasPermissibleNetzero()) {
      hash = (37 * hash) + PERMISSIBLENETZERO_FIELD_NUMBER;
      hash = (53 * hash) + getPermissibleNetzero().hashCode();
    }
    if (hasPermissibleStart()) {
      hash = (37 * hash) + PERMISSIBLESTART_FIELD_NUMBER;
      hash = (53 * hash) + getPermissibleStart().hashCode();
    }
    if (hasPermissibleStop()) {
      hash = (37 * hash) + PERMISSIBLESTOP_FIELD_NUMBER;
      hash = (53 * hash) + getPermissibleStop().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * OpenFMB specialization for circuit segment service control, DCSC (Distributed Coordination
   * Service Control), following 61850 naming convention.
   * </pre>
   *
   * Protobuf type {@code circuitsegmentservicemodule.CircuitSegmentEventDCSC}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:circuitsegmentservicemodule.CircuitSegmentEventDCSC)
      openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSCOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.circuitsegmentservicemodule.Circuitsegmentservicemodule.internal_static_circuitsegmentservicemodule_CircuitSegmentEventDCSC_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.circuitsegmentservicemodule.Circuitsegmentservicemodule.internal_static_circuitsegmentservicemodule_CircuitSegmentEventDCSC_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC.class, openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC.Builder.class);
    }

    // Construct using openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      logicalNode_ = null;
      if (logicalNodeBuilder_ != null) {
        logicalNodeBuilder_.dispose();
        logicalNodeBuilder_ = null;
      }
      circuitSegmentServiceMode_ = null;
      if (circuitSegmentServiceModeBuilder_ != null) {
        circuitSegmentServiceModeBuilder_.dispose();
        circuitSegmentServiceModeBuilder_ = null;
      }
      island_ = null;
      if (islandBuilder_ != null) {
        islandBuilder_.dispose();
        islandBuilder_ = null;
      }
      permissibleAuto_ = null;
      if (permissibleAutoBuilder_ != null) {
        permissibleAutoBuilder_.dispose();
        permissibleAutoBuilder_ = null;
      }
      permissibleManual_ = null;
      if (permissibleManualBuilder_ != null) {
        permissibleManualBuilder_.dispose();
        permissibleManualBuilder_ = null;
      }
      permissibleNetzero_ = null;
      if (permissibleNetzeroBuilder_ != null) {
        permissibleNetzeroBuilder_.dispose();
        permissibleNetzeroBuilder_ = null;
      }
      permissibleStart_ = null;
      if (permissibleStartBuilder_ != null) {
        permissibleStartBuilder_.dispose();
        permissibleStartBuilder_ = null;
      }
      permissibleStop_ = null;
      if (permissibleStopBuilder_ != null) {
        permissibleStopBuilder_.dispose();
        permissibleStopBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.circuitsegmentservicemodule.Circuitsegmentservicemodule.internal_static_circuitsegmentservicemodule_CircuitSegmentEventDCSC_descriptor;
    }

    @java.lang.Override
    public openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC getDefaultInstanceForType() {
      return openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC build() {
      openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC buildPartial() {
      openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC result = new openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.logicalNode_ = logicalNodeBuilder_ == null
            ? logicalNode_
            : logicalNodeBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.circuitSegmentServiceMode_ = circuitSegmentServiceModeBuilder_ == null
            ? circuitSegmentServiceMode_
            : circuitSegmentServiceModeBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.island_ = islandBuilder_ == null
            ? island_
            : islandBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000008) != 0)) {
        result.permissibleAuto_ = permissibleAutoBuilder_ == null
            ? permissibleAuto_
            : permissibleAutoBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000010) != 0)) {
        result.permissibleManual_ = permissibleManualBuilder_ == null
            ? permissibleManual_
            : permissibleManualBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000020) != 0)) {
        result.permissibleNetzero_ = permissibleNetzeroBuilder_ == null
            ? permissibleNetzero_
            : permissibleNetzeroBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000040) != 0)) {
        result.permissibleStart_ = permissibleStartBuilder_ == null
            ? permissibleStart_
            : permissibleStartBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000080) != 0)) {
        result.permissibleStop_ = permissibleStopBuilder_ == null
            ? permissibleStop_
            : permissibleStopBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC) {
        return mergeFrom((openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC other) {
      if (other == openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC.getDefaultInstance()) return this;
      if (other.hasLogicalNode()) {
        mergeLogicalNode(other.getLogicalNode());
      }
      if (other.hasCircuitSegmentServiceMode()) {
        mergeCircuitSegmentServiceMode(other.getCircuitSegmentServiceMode());
      }
      if (other.hasIsland()) {
        mergeIsland(other.getIsland());
      }
      if (other.hasPermissibleAuto()) {
        mergePermissibleAuto(other.getPermissibleAuto());
      }
      if (other.hasPermissibleManual()) {
        mergePermissibleManual(other.getPermissibleManual());
      }
      if (other.hasPermissibleNetzero()) {
        mergePermissibleNetzero(other.getPermissibleNetzero());
      }
      if (other.hasPermissibleStart()) {
        mergePermissibleStart(other.getPermissibleStart());
      }
      if (other.hasPermissibleStop()) {
        mergePermissibleStop(other.getPermissibleStop());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getLogicalNodeFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getCircuitSegmentServiceModeFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getIslandFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            case 34: {
              input.readMessage(
                  getPermissibleAutoFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000008;
              break;
            } // case 34
            case 42: {
              input.readMessage(
                  getPermissibleManualFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000010;
              break;
            } // case 42
            case 50: {
              input.readMessage(
                  getPermissibleNetzeroFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000020;
              break;
            } // case 50
            case 58: {
              input.readMessage(
                  getPermissibleStartFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000040;
              break;
            } // case 58
            case 66: {
              input.readMessage(
                  getPermissibleStopFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000080;
              break;
            } // case 66
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.LogicalNode logicalNode_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.LogicalNode, openfmb.commonmodule.LogicalNode.Builder, openfmb.commonmodule.LogicalNodeOrBuilder> logicalNodeBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the logicalNode field is set.
     */
    public boolean hasLogicalNode() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     * @return The logicalNode.
     */
    public openfmb.commonmodule.LogicalNode getLogicalNode() {
      if (logicalNodeBuilder_ == null) {
        return logicalNode_ == null ? openfmb.commonmodule.LogicalNode.getDefaultInstance() : logicalNode_;
      } else {
        return logicalNodeBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setLogicalNode(openfmb.commonmodule.LogicalNode value) {
      if (logicalNodeBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        logicalNode_ = value;
      } else {
        logicalNodeBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setLogicalNode(
        openfmb.commonmodule.LogicalNode.Builder builderForValue) {
      if (logicalNodeBuilder_ == null) {
        logicalNode_ = builderForValue.build();
      } else {
        logicalNodeBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeLogicalNode(openfmb.commonmodule.LogicalNode value) {
      if (logicalNodeBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          logicalNode_ != null &&
          logicalNode_ != openfmb.commonmodule.LogicalNode.getDefaultInstance()) {
          getLogicalNodeBuilder().mergeFrom(value);
        } else {
          logicalNode_ = value;
        }
      } else {
        logicalNodeBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearLogicalNode() {
      bitField0_ = (bitField0_ & ~0x00000001);
      logicalNode_ = null;
      if (logicalNodeBuilder_ != null) {
        logicalNodeBuilder_.dispose();
        logicalNodeBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.LogicalNode.Builder getLogicalNodeBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getLogicalNodeFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.LogicalNodeOrBuilder getLogicalNodeOrBuilder() {
      if (logicalNodeBuilder_ != null) {
        return logicalNodeBuilder_.getMessageOrBuilder();
      } else {
        return logicalNode_ == null ?
            openfmb.commonmodule.LogicalNode.getDefaultInstance() : logicalNode_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.LogicalNode, openfmb.commonmodule.LogicalNode.Builder, openfmb.commonmodule.LogicalNodeOrBuilder> 
        getLogicalNodeFieldBuilder() {
      if (logicalNodeBuilder_ == null) {
        logicalNodeBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.LogicalNode, openfmb.commonmodule.LogicalNode.Builder, openfmb.commonmodule.LogicalNodeOrBuilder>(
                getLogicalNode(),
                getParentForChildren(),
                isClean());
        logicalNode_ = null;
      }
      return logicalNodeBuilder_;
    }

    private openfmb.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind circuitSegmentServiceMode_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind, openfmb.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind.Builder, openfmb.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKindOrBuilder> circuitSegmentServiceModeBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind CircuitSegmentServiceMode = 2;</code>
     * @return Whether the circuitSegmentServiceMode field is set.
     */
    public boolean hasCircuitSegmentServiceMode() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind CircuitSegmentServiceMode = 2;</code>
     * @return The circuitSegmentServiceMode.
     */
    public openfmb.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind getCircuitSegmentServiceMode() {
      if (circuitSegmentServiceModeBuilder_ == null) {
        return circuitSegmentServiceMode_ == null ? openfmb.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind.getDefaultInstance() : circuitSegmentServiceMode_;
      } else {
        return circuitSegmentServiceModeBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind CircuitSegmentServiceMode = 2;</code>
     */
    public Builder setCircuitSegmentServiceMode(openfmb.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind value) {
      if (circuitSegmentServiceModeBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        circuitSegmentServiceMode_ = value;
      } else {
        circuitSegmentServiceModeBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind CircuitSegmentServiceMode = 2;</code>
     */
    public Builder setCircuitSegmentServiceMode(
        openfmb.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind.Builder builderForValue) {
      if (circuitSegmentServiceModeBuilder_ == null) {
        circuitSegmentServiceMode_ = builderForValue.build();
      } else {
        circuitSegmentServiceModeBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind CircuitSegmentServiceMode = 2;</code>
     */
    public Builder mergeCircuitSegmentServiceMode(openfmb.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind value) {
      if (circuitSegmentServiceModeBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          circuitSegmentServiceMode_ != null &&
          circuitSegmentServiceMode_ != openfmb.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind.getDefaultInstance()) {
          getCircuitSegmentServiceModeBuilder().mergeFrom(value);
        } else {
          circuitSegmentServiceMode_ = value;
        }
      } else {
        circuitSegmentServiceModeBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind CircuitSegmentServiceMode = 2;</code>
     */
    public Builder clearCircuitSegmentServiceMode() {
      bitField0_ = (bitField0_ & ~0x00000002);
      circuitSegmentServiceMode_ = null;
      if (circuitSegmentServiceModeBuilder_ != null) {
        circuitSegmentServiceModeBuilder_.dispose();
        circuitSegmentServiceModeBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind CircuitSegmentServiceMode = 2;</code>
     */
    public openfmb.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind.Builder getCircuitSegmentServiceModeBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getCircuitSegmentServiceModeFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind CircuitSegmentServiceMode = 2;</code>
     */
    public openfmb.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKindOrBuilder getCircuitSegmentServiceModeOrBuilder() {
      if (circuitSegmentServiceModeBuilder_ != null) {
        return circuitSegmentServiceModeBuilder_.getMessageOrBuilder();
      } else {
        return circuitSegmentServiceMode_ == null ?
            openfmb.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind.getDefaultInstance() : circuitSegmentServiceMode_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind CircuitSegmentServiceMode = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind, openfmb.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind.Builder, openfmb.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKindOrBuilder> 
        getCircuitSegmentServiceModeFieldBuilder() {
      if (circuitSegmentServiceModeBuilder_ == null) {
        circuitSegmentServiceModeBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind, openfmb.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKind.Builder, openfmb.circuitsegmentservicemodule.ENG_CircuitSegmentServiceModeKindOrBuilder>(
                getCircuitSegmentServiceMode(),
                getParentForChildren(),
                isClean());
        circuitSegmentServiceMode_ = null;
      }
      return circuitSegmentServiceModeBuilder_;
    }

    private openfmb.commonmodule.StatusSPS island_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> islandBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS Island = 3;</code>
     * @return Whether the island field is set.
     */
    public boolean hasIsland() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS Island = 3;</code>
     * @return The island.
     */
    public openfmb.commonmodule.StatusSPS getIsland() {
      if (islandBuilder_ == null) {
        return island_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : island_;
      } else {
        return islandBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS Island = 3;</code>
     */
    public Builder setIsland(openfmb.commonmodule.StatusSPS value) {
      if (islandBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        island_ = value;
      } else {
        islandBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS Island = 3;</code>
     */
    public Builder setIsland(
        openfmb.commonmodule.StatusSPS.Builder builderForValue) {
      if (islandBuilder_ == null) {
        island_ = builderForValue.build();
      } else {
        islandBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS Island = 3;</code>
     */
    public Builder mergeIsland(openfmb.commonmodule.StatusSPS value) {
      if (islandBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          island_ != null &&
          island_ != openfmb.commonmodule.StatusSPS.getDefaultInstance()) {
          getIslandBuilder().mergeFrom(value);
        } else {
          island_ = value;
        }
      } else {
        islandBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS Island = 3;</code>
     */
    public Builder clearIsland() {
      bitField0_ = (bitField0_ & ~0x00000004);
      island_ = null;
      if (islandBuilder_ != null) {
        islandBuilder_.dispose();
        islandBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS Island = 3;</code>
     */
    public openfmb.commonmodule.StatusSPS.Builder getIslandBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getIslandFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS Island = 3;</code>
     */
    public openfmb.commonmodule.StatusSPSOrBuilder getIslandOrBuilder() {
      if (islandBuilder_ != null) {
        return islandBuilder_.getMessageOrBuilder();
      } else {
        return island_ == null ?
            openfmb.commonmodule.StatusSPS.getDefaultInstance() : island_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS Island = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> 
        getIslandFieldBuilder() {
      if (islandBuilder_ == null) {
        islandBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder>(
                getIsland(),
                getParentForChildren(),
                isClean());
        island_ = null;
      }
      return islandBuilder_;
    }

    private openfmb.commonmodule.StatusSPS permissibleAuto_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> permissibleAutoBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleAuto = 4;</code>
     * @return Whether the permissibleAuto field is set.
     */
    public boolean hasPermissibleAuto() {
      return ((bitField0_ & 0x00000008) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleAuto = 4;</code>
     * @return The permissibleAuto.
     */
    public openfmb.commonmodule.StatusSPS getPermissibleAuto() {
      if (permissibleAutoBuilder_ == null) {
        return permissibleAuto_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : permissibleAuto_;
      } else {
        return permissibleAutoBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleAuto = 4;</code>
     */
    public Builder setPermissibleAuto(openfmb.commonmodule.StatusSPS value) {
      if (permissibleAutoBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        permissibleAuto_ = value;
      } else {
        permissibleAutoBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleAuto = 4;</code>
     */
    public Builder setPermissibleAuto(
        openfmb.commonmodule.StatusSPS.Builder builderForValue) {
      if (permissibleAutoBuilder_ == null) {
        permissibleAuto_ = builderForValue.build();
      } else {
        permissibleAutoBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleAuto = 4;</code>
     */
    public Builder mergePermissibleAuto(openfmb.commonmodule.StatusSPS value) {
      if (permissibleAutoBuilder_ == null) {
        if (((bitField0_ & 0x00000008) != 0) &&
          permissibleAuto_ != null &&
          permissibleAuto_ != openfmb.commonmodule.StatusSPS.getDefaultInstance()) {
          getPermissibleAutoBuilder().mergeFrom(value);
        } else {
          permissibleAuto_ = value;
        }
      } else {
        permissibleAutoBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleAuto = 4;</code>
     */
    public Builder clearPermissibleAuto() {
      bitField0_ = (bitField0_ & ~0x00000008);
      permissibleAuto_ = null;
      if (permissibleAutoBuilder_ != null) {
        permissibleAutoBuilder_.dispose();
        permissibleAutoBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleAuto = 4;</code>
     */
    public openfmb.commonmodule.StatusSPS.Builder getPermissibleAutoBuilder() {
      bitField0_ |= 0x00000008;
      onChanged();
      return getPermissibleAutoFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleAuto = 4;</code>
     */
    public openfmb.commonmodule.StatusSPSOrBuilder getPermissibleAutoOrBuilder() {
      if (permissibleAutoBuilder_ != null) {
        return permissibleAutoBuilder_.getMessageOrBuilder();
      } else {
        return permissibleAuto_ == null ?
            openfmb.commonmodule.StatusSPS.getDefaultInstance() : permissibleAuto_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleAuto = 4;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> 
        getPermissibleAutoFieldBuilder() {
      if (permissibleAutoBuilder_ == null) {
        permissibleAutoBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder>(
                getPermissibleAuto(),
                getParentForChildren(),
                isClean());
        permissibleAuto_ = null;
      }
      return permissibleAutoBuilder_;
    }

    private openfmb.commonmodule.StatusSPS permissibleManual_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> permissibleManualBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleManual = 5;</code>
     * @return Whether the permissibleManual field is set.
     */
    public boolean hasPermissibleManual() {
      return ((bitField0_ & 0x00000010) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleManual = 5;</code>
     * @return The permissibleManual.
     */
    public openfmb.commonmodule.StatusSPS getPermissibleManual() {
      if (permissibleManualBuilder_ == null) {
        return permissibleManual_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : permissibleManual_;
      } else {
        return permissibleManualBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleManual = 5;</code>
     */
    public Builder setPermissibleManual(openfmb.commonmodule.StatusSPS value) {
      if (permissibleManualBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        permissibleManual_ = value;
      } else {
        permissibleManualBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleManual = 5;</code>
     */
    public Builder setPermissibleManual(
        openfmb.commonmodule.StatusSPS.Builder builderForValue) {
      if (permissibleManualBuilder_ == null) {
        permissibleManual_ = builderForValue.build();
      } else {
        permissibleManualBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleManual = 5;</code>
     */
    public Builder mergePermissibleManual(openfmb.commonmodule.StatusSPS value) {
      if (permissibleManualBuilder_ == null) {
        if (((bitField0_ & 0x00000010) != 0) &&
          permissibleManual_ != null &&
          permissibleManual_ != openfmb.commonmodule.StatusSPS.getDefaultInstance()) {
          getPermissibleManualBuilder().mergeFrom(value);
        } else {
          permissibleManual_ = value;
        }
      } else {
        permissibleManualBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleManual = 5;</code>
     */
    public Builder clearPermissibleManual() {
      bitField0_ = (bitField0_ & ~0x00000010);
      permissibleManual_ = null;
      if (permissibleManualBuilder_ != null) {
        permissibleManualBuilder_.dispose();
        permissibleManualBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleManual = 5;</code>
     */
    public openfmb.commonmodule.StatusSPS.Builder getPermissibleManualBuilder() {
      bitField0_ |= 0x00000010;
      onChanged();
      return getPermissibleManualFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleManual = 5;</code>
     */
    public openfmb.commonmodule.StatusSPSOrBuilder getPermissibleManualOrBuilder() {
      if (permissibleManualBuilder_ != null) {
        return permissibleManualBuilder_.getMessageOrBuilder();
      } else {
        return permissibleManual_ == null ?
            openfmb.commonmodule.StatusSPS.getDefaultInstance() : permissibleManual_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleManual = 5;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> 
        getPermissibleManualFieldBuilder() {
      if (permissibleManualBuilder_ == null) {
        permissibleManualBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder>(
                getPermissibleManual(),
                getParentForChildren(),
                isClean());
        permissibleManual_ = null;
      }
      return permissibleManualBuilder_;
    }

    private openfmb.commonmodule.StatusSPS permissibleNetzero_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> permissibleNetzeroBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleNetzero = 6;</code>
     * @return Whether the permissibleNetzero field is set.
     */
    public boolean hasPermissibleNetzero() {
      return ((bitField0_ & 0x00000020) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleNetzero = 6;</code>
     * @return The permissibleNetzero.
     */
    public openfmb.commonmodule.StatusSPS getPermissibleNetzero() {
      if (permissibleNetzeroBuilder_ == null) {
        return permissibleNetzero_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : permissibleNetzero_;
      } else {
        return permissibleNetzeroBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleNetzero = 6;</code>
     */
    public Builder setPermissibleNetzero(openfmb.commonmodule.StatusSPS value) {
      if (permissibleNetzeroBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        permissibleNetzero_ = value;
      } else {
        permissibleNetzeroBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleNetzero = 6;</code>
     */
    public Builder setPermissibleNetzero(
        openfmb.commonmodule.StatusSPS.Builder builderForValue) {
      if (permissibleNetzeroBuilder_ == null) {
        permissibleNetzero_ = builderForValue.build();
      } else {
        permissibleNetzeroBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleNetzero = 6;</code>
     */
    public Builder mergePermissibleNetzero(openfmb.commonmodule.StatusSPS value) {
      if (permissibleNetzeroBuilder_ == null) {
        if (((bitField0_ & 0x00000020) != 0) &&
          permissibleNetzero_ != null &&
          permissibleNetzero_ != openfmb.commonmodule.StatusSPS.getDefaultInstance()) {
          getPermissibleNetzeroBuilder().mergeFrom(value);
        } else {
          permissibleNetzero_ = value;
        }
      } else {
        permissibleNetzeroBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleNetzero = 6;</code>
     */
    public Builder clearPermissibleNetzero() {
      bitField0_ = (bitField0_ & ~0x00000020);
      permissibleNetzero_ = null;
      if (permissibleNetzeroBuilder_ != null) {
        permissibleNetzeroBuilder_.dispose();
        permissibleNetzeroBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleNetzero = 6;</code>
     */
    public openfmb.commonmodule.StatusSPS.Builder getPermissibleNetzeroBuilder() {
      bitField0_ |= 0x00000020;
      onChanged();
      return getPermissibleNetzeroFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleNetzero = 6;</code>
     */
    public openfmb.commonmodule.StatusSPSOrBuilder getPermissibleNetzeroOrBuilder() {
      if (permissibleNetzeroBuilder_ != null) {
        return permissibleNetzeroBuilder_.getMessageOrBuilder();
      } else {
        return permissibleNetzero_ == null ?
            openfmb.commonmodule.StatusSPS.getDefaultInstance() : permissibleNetzero_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleNetzero = 6;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> 
        getPermissibleNetzeroFieldBuilder() {
      if (permissibleNetzeroBuilder_ == null) {
        permissibleNetzeroBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder>(
                getPermissibleNetzero(),
                getParentForChildren(),
                isClean());
        permissibleNetzero_ = null;
      }
      return permissibleNetzeroBuilder_;
    }

    private openfmb.commonmodule.StatusSPS permissibleStart_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> permissibleStartBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleStart = 7;</code>
     * @return Whether the permissibleStart field is set.
     */
    public boolean hasPermissibleStart() {
      return ((bitField0_ & 0x00000040) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleStart = 7;</code>
     * @return The permissibleStart.
     */
    public openfmb.commonmodule.StatusSPS getPermissibleStart() {
      if (permissibleStartBuilder_ == null) {
        return permissibleStart_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : permissibleStart_;
      } else {
        return permissibleStartBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleStart = 7;</code>
     */
    public Builder setPermissibleStart(openfmb.commonmodule.StatusSPS value) {
      if (permissibleStartBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        permissibleStart_ = value;
      } else {
        permissibleStartBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000040;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleStart = 7;</code>
     */
    public Builder setPermissibleStart(
        openfmb.commonmodule.StatusSPS.Builder builderForValue) {
      if (permissibleStartBuilder_ == null) {
        permissibleStart_ = builderForValue.build();
      } else {
        permissibleStartBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000040;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleStart = 7;</code>
     */
    public Builder mergePermissibleStart(openfmb.commonmodule.StatusSPS value) {
      if (permissibleStartBuilder_ == null) {
        if (((bitField0_ & 0x00000040) != 0) &&
          permissibleStart_ != null &&
          permissibleStart_ != openfmb.commonmodule.StatusSPS.getDefaultInstance()) {
          getPermissibleStartBuilder().mergeFrom(value);
        } else {
          permissibleStart_ = value;
        }
      } else {
        permissibleStartBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000040;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleStart = 7;</code>
     */
    public Builder clearPermissibleStart() {
      bitField0_ = (bitField0_ & ~0x00000040);
      permissibleStart_ = null;
      if (permissibleStartBuilder_ != null) {
        permissibleStartBuilder_.dispose();
        permissibleStartBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleStart = 7;</code>
     */
    public openfmb.commonmodule.StatusSPS.Builder getPermissibleStartBuilder() {
      bitField0_ |= 0x00000040;
      onChanged();
      return getPermissibleStartFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleStart = 7;</code>
     */
    public openfmb.commonmodule.StatusSPSOrBuilder getPermissibleStartOrBuilder() {
      if (permissibleStartBuilder_ != null) {
        return permissibleStartBuilder_.getMessageOrBuilder();
      } else {
        return permissibleStart_ == null ?
            openfmb.commonmodule.StatusSPS.getDefaultInstance() : permissibleStart_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleStart = 7;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> 
        getPermissibleStartFieldBuilder() {
      if (permissibleStartBuilder_ == null) {
        permissibleStartBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder>(
                getPermissibleStart(),
                getParentForChildren(),
                isClean());
        permissibleStart_ = null;
      }
      return permissibleStartBuilder_;
    }

    private openfmb.commonmodule.StatusSPS permissibleStop_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> permissibleStopBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleStop = 8;</code>
     * @return Whether the permissibleStop field is set.
     */
    public boolean hasPermissibleStop() {
      return ((bitField0_ & 0x00000080) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleStop = 8;</code>
     * @return The permissibleStop.
     */
    public openfmb.commonmodule.StatusSPS getPermissibleStop() {
      if (permissibleStopBuilder_ == null) {
        return permissibleStop_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : permissibleStop_;
      } else {
        return permissibleStopBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleStop = 8;</code>
     */
    public Builder setPermissibleStop(openfmb.commonmodule.StatusSPS value) {
      if (permissibleStopBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        permissibleStop_ = value;
      } else {
        permissibleStopBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000080;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleStop = 8;</code>
     */
    public Builder setPermissibleStop(
        openfmb.commonmodule.StatusSPS.Builder builderForValue) {
      if (permissibleStopBuilder_ == null) {
        permissibleStop_ = builderForValue.build();
      } else {
        permissibleStopBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000080;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleStop = 8;</code>
     */
    public Builder mergePermissibleStop(openfmb.commonmodule.StatusSPS value) {
      if (permissibleStopBuilder_ == null) {
        if (((bitField0_ & 0x00000080) != 0) &&
          permissibleStop_ != null &&
          permissibleStop_ != openfmb.commonmodule.StatusSPS.getDefaultInstance()) {
          getPermissibleStopBuilder().mergeFrom(value);
        } else {
          permissibleStop_ = value;
        }
      } else {
        permissibleStopBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000080;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleStop = 8;</code>
     */
    public Builder clearPermissibleStop() {
      bitField0_ = (bitField0_ & ~0x00000080);
      permissibleStop_ = null;
      if (permissibleStopBuilder_ != null) {
        permissibleStopBuilder_.dispose();
        permissibleStopBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleStop = 8;</code>
     */
    public openfmb.commonmodule.StatusSPS.Builder getPermissibleStopBuilder() {
      bitField0_ |= 0x00000080;
      onChanged();
      return getPermissibleStopFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleStop = 8;</code>
     */
    public openfmb.commonmodule.StatusSPSOrBuilder getPermissibleStopOrBuilder() {
      if (permissibleStopBuilder_ != null) {
        return permissibleStopBuilder_.getMessageOrBuilder();
      } else {
        return permissibleStop_ == null ?
            openfmb.commonmodule.StatusSPS.getDefaultInstance() : permissibleStop_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS PermissibleStop = 8;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> 
        getPermissibleStopFieldBuilder() {
      if (permissibleStopBuilder_ == null) {
        permissibleStopBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder>(
                getPermissibleStop(),
                getParentForChildren(),
                isClean());
        permissibleStop_ = null;
      }
      return permissibleStopBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:circuitsegmentservicemodule.CircuitSegmentEventDCSC)
  }

  // @@protoc_insertion_point(class_scope:circuitsegmentservicemodule.CircuitSegmentEventDCSC)
  private static final openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC();
  }

  public static openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<CircuitSegmentEventDCSC>
      PARSER = new com.google.protobuf.AbstractParser<CircuitSegmentEventDCSC>() {
    @java.lang.Override
    public CircuitSegmentEventDCSC parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<CircuitSegmentEventDCSC> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<CircuitSegmentEventDCSC> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.circuitsegmentservicemodule.CircuitSegmentEventDCSC getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

